/*
 * Initial main.cpp file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "splash.h"
#include "winconst.h"

char *DB_NAME = NULL;

int main (int argc, char *argv[])
{
  
#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

#ifdef HAVE_CONFIG_H
  add_pixmap_directory (PACKAGE_DATA_DIR G_DIR_SEPARATOR_S PACKAGE G_DIR_SEPARATOR_S "pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR G_DIR_SEPARATOR_S "pixmaps");
  add_pixmap_directory (PACKAGE_PIXMAPS_DIR);
  add_pixmap_directory (PACKAGE_DOC_DIR);
#endif
  add_pixmap_directory ("." G_DIR_SEPARATOR_S "pixmaps");
  add_pixmap_directory ("." G_DIR_SEPARATOR_S "doc");	

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */

	if (argc >= 2) {
		if (g_str_equal(argv[1],"-f") && argc == 3)
			DB_NAME = g_strdup(argv[1]);
		else if (g_str_equal(argv[1],"-v")) {
			printf(_("GeodeTKa %s - program do podstawowych obliczeń geodezyjnych\n"), VERSION);
			return 0;
		}
		else {
			printf(_("Użycie: geodetka [opcje]\n"));
			printf(_("  -h            Wyświetla ten komunikat i kończy działanie\n"));
			printf(_("  -v            Wyświetla wersję programu i kończy działanie\n"));
			printf(_("  -f <plik.db>  Plik bazy danych (domyślnie geodetka.db)\n"));
      	return 0;
		}
   }
	else {
#ifdef G_OS_UNIX
			DB_NAME = g_strdup_printf("%s%s%s", g_get_home_dir(), G_DIR_SEPARATOR_S, "geodetka.sq3");
#else
			DB_NAME = "geodetka.sq3";
#endif
	}

	GtkWidget *winSplash = create_winSplash ();
	gtk_widget_show(winSplash);
	gtk_main();
	return 0;
}
